### Method

# Gio OutputStream writev

since: 2.60

#### Declaration

    gboolean
    g_output_stream_writev (
      GOutputStream* stream,
      const GOutputVector* vectors,
      gsize n_vectors,
      gsize* bytes_written,
      GCancellable* cancellable,
      GError** error
    )

#### Description

Tries to write the bytes contained in the `n_vectors` `vectors` into the stream. Will block during the operation.

If `n_vectors` is 0 or the sum of all bytes in `vectors` is 0, returns 0 and does nothing.

On success, the number of bytes written to the stream is returned. It is not an error if this is not the same as the requested size, as it can happen e.g. on a partial I/O error, or if there is not enough storage in the stream. All writes block until at least one byte is written or an error occurs; 0 is never returned (unless `n_vectors` is 0 or the sum of all bytes in `vectors` is 0).

If `cancellable` is not `NULL`, then the operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, the error `G_IO_ERROR_CANCELLED` will be returned. If an operation was partially finished when the operation was cancelled the partial result will be returned, without an error.

Some implementations of `g_output_stream_writev()` may have limitations on the aggregate buffer size, and will return `G_IO_ERROR_INVALID_ARGUMENT` if these are exceeded. For example, when writing to a local file on UNIX platforms, the aggregate buffer size must not exceed `G_MAXSSIZE` bytes.

Available since: 2.60

#### Parameters

`vectors`

  Type: An array of `GOutputVector`

  The buffer containing the `GOutputVectors` to write.

  The length of the array is specified in the `n_vectors` argument.
  The data is owned by the caller of the method.

`n_vectors`

  Type: `gsize`

  The number of vectors to write.

`bytes_written`

  Type: `gsize*`

  Location to store the number of bytes that were written to the stream.

  The argument will be set by the function.
  The argument can be `NULL`.

`cancellable`

  Type: `GCancellable`

  Optional cancellable object.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gboolean`

`TRUE` on success, `FALSE` if there was an error.